/*
File: ControlApplication.java
Date		Author		Changes
Mar 07 97	Lukasz Beca	Created
Nov 20 97   K Olszewski changed method of applet starting
*/
 
package webwisdom.tango.structures;

import webwisdom.tango.messages.*;
import webwisdom.tango.main.LocalBase;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.structures.CentralServer;
import webwisdom.tango.interfaces.ControlAppletBase;
import netscape.javascript.JSObject;
import webwisdom.tango.structures.Registrar;
import webwisdom.tango.structures.MessageQueue;
import webwisdom.tango.consts.Const;

import java.lang.*;
import java.net.*;
import java.io.*;


public class ControlApplication implements Runnable{

  private LocalBase lb;
  private CentralServer cs;
  private ControlAppletBase cab;
  private LocalApplications apps;
  private Registrar reg;
  private int wincounter;
  private Thread th;
  private MessageQueue q;
  private boolean noexit;
  private int endMode;
  private int init_status;

  public ControlApplication() {

    System.out.println("ControlDemon: creating controldemon");

    wincounter = 1;
    lb = null;
    cs = null;
    cab = null;
    apps = null;
    reg = null;
    th = null;   
    noexit = true;
    q = new MessageQueue();
    endMode = Const.NONE;
    init_status = Const.OK;
   
  }

  //interface for LocalApplications
  //public void receiveFromApplication(int AID, Message m);
  //public void removeApplication(int AID);
  //public void errorApplication(int AID);

  public void sendLAToCAB(int AID, AppEventMessage am) {

    EventMessage em = new EventMessage(AID, am.getData());
    q.putMessage(em);

  } 
  public void removeApplication(int AID) {

    cab.removeApplication(AID);


  }
  public void errorApplication(int AID){}

  //interface for CentralServer
  //public void receiveFromServer(Message m);
  //public void errorServer(int errorCode);

  public void sendCSToCAB(Message m) {

    q.putMessage(m);

  }

  public void errorServer(int errorCode) {

    System.out.println("ControlDemon: errorServer called");

    if (endMode == Const.NONE) {

      switch(errorCode) {
      
	      case Const.CONNBROKEN: 

		      System.out.println("ControlDemon: connection broken");
			    endMode = Const.CONNECTIONEND; 
			    cab.error(Const.CONNBROKEN); 
		      apps.finishAll();
		      apps.end();
		      reg.end();
		      noexit = false;
		      q.unblock(); 
		      break;
 
	      case Const.UNABLETOCONNECT:
		      System.out.println("ControlDemon: unable to connect");
		      endMode = Const.CONNECTIONEND;
		      init_status = Const.UNABLETOCONNECT;	 
		      System.out.println("ControlDemon: error handled");
		     // apps.end();
		     // reg.end();	 	 
			   // endAll();			   
		      break;	  

      }
    } else {

      System.out.println("ControlDemon: connection closed");

    }   

  }


  //interface for LocalBase
  //public void errorLocalBase(int errCode);
  //public void initAssociations(LocalBase lbpar, CentralServer cspar, LocalApplicatons lapar, Registrar regpar);
  //public void terminated();

  public void initAssociations(LocalBase lbpar, CentralServer cspar, LocalApplications lapar, Registrar regpar) {

    lb = lbpar;
    cs = cspar;
    apps = lapar;
    reg = regpar;

  }
  public void errorLocalBase(int errCode) {

    System.out.println("ControlDemon: error no. " + errCode);

  }

  public void terminated() {
   
    if (endMode == Const.NONE) {
      System.out.println("ControlDemon: window closed");
      endMode = Const.TERMINATEDEND;
      emergLogout();
      apps.finishAll();
      apps.end();
      reg.end();
      noexit = false;
      q.unblock();
      System.out.println("ControlDemon: queue unblocked"); 
    }
  }

  //interface for ControlAppletBase
  //public void sendCABToCS(Message m);
  //public void sendCABToApp(int AID, Message m);
  //public void finish(int AID);
  //public void logout();
  //public boolean appExists(int AID);
  //public void startApplet(String url, int AID, String height, String width);
  //public void startApplet(String url, int AID, String framename);
  //public void startApplication(int AT, int AID);
  //public void startApplication(String path, String name, String args);
  //public void setFocus(int AID);
  //public int getStatus();
  //public String getServerHost();

  public void sendCABToCS(Message m) {

    cs.sendCAToCS(m);

  }

  public void sendCABToApp(int AID, Message m) {

    AppEventMessage am = (AppEventMessage) m;

    apps.sendCAToApp(AID, am);


  }
  public void finish(int AID) {

    apps.finish(AID);

  }

  public void logout() {

    if (endMode == Const.NONE) {
      System.out.println("ControlDemon: logout called");
      endMode = Const.LOGOUTEND;
      apps.finishAll();
      apps.end();
      reg.end();
 
      noexit = false;
      q.unblock(); 
       
     
    }
  }

  public boolean appExists(int AID) {

    return apps.appInSession(AID);
  }
  
  
  public String getServerHost() {
  
  		return cs.getServerHost();
  
  }
  
//prototype method for applet start

	public synchronized void startApplet(String url, int AID, int SID, int AT, String height, String width) {


    JSObject win, caframe, newwin;
    String options, winname, com;  

    caframe = (JSObject) JSObject.getWindow(cab);
    if (caframe == null) {
      System.out.println("Local: unable to get reference to frame");    
      caframe = null;
    } 

    win = (JSObject) caframe.getMember("top");
    if (win == null) {
      System.out.println("Local: unable to get reference to top window");       
      win = null;
    } 
    
    options = new String("\"toolbar=no,location=no,directories=no,status=no,menubar=no,resizable=no,scrollbars=no,width=" + width + ",height=" + height + "\"");

    winname = new String("win" + AID + "_" + SID + "_" + AT);
    com = new String("open(\"" + url + "\",\"" + winname + "\"," + options + ");");

    newwin = (JSObject) win.eval(com);
    System.out.println("Local: running " + com);

  }
// end of prototype method


  public synchronized void startApplet(String url, int AID, String framename) {

//    JSObject parent = (JSObject) JSObject.getWindow(cab).getMember("parent");
//    JSObject newwin, newdoc, frame, tmp;
//    Object args[] = new Object[3];

    // setAID(AID);

    //System.out.println("DemonProtocol: getting frame");
//    try {
//        frame = (JSObject) parent.getMember(framename);

//        args[0] = "null.html";
//        args[1] = framename;
//        args[2] = null;

      //System.out.println("ARGS: " + (String) args[0] + " " + (String) args[1]);

//        reg.setAID(AID);
//        tmp = (JSObject) frame.call("open", args);
//        JSObject doc=(JSObject)tmp.getMember("document");
//        String arg[]={"text/html","replace"};
//        String ar[]={processHTML(url,AID)};
//        doc.call("open",arg);
//		doc.call("writeln",ar);
//   		doc.call("close",null);
//    }
//    catch (Exception e) {}
  }

  public void startApplication(String path, int AID, int SID, int AT) {

    lb.startApplication(path, AID, SID, AT, reg.getLocalPort());

  }  

  public void setFocus(int AID) {

    apps.setFocus(AID);

  }

  public int getStatus() {
  
    return init_status;
  
  }


  //interface for Registrar
  //public void init(ControlAppletBase cabparam);
  //public void errorRegistrar(int errorCode);
  //public void addApplication(int AID, int SID, int AT);

  public void init(ControlAppletBase cabparam) {

    cab = cabparam;
    th = new Thread(this);
    th.start();

  }

  public void errorRegistrar(int errorCode) {}
  
  
  public void addApplication(int AID, int SID, int AT) {
  
  		cab.addApplication(AID, SID, AT);
  
  }

  //internal methods
  //private void run();
  //private void endAll();
  //private void emergLogout();

  public void run() {

    Message m;
    AppEventMessage am;
    EventMessage em;
    int lAID;
   

    System.out.println("ControlDemon: control applet thread number started");
   
    
    while(noexit) {

	  //System.out.println("ThreadOut: Thread number " + thisno + " sending");
      m = q.getMessage();

      if (m.getType() != Const.EVENT) {

	cab.receiveServer(m);

      } else {
	
	 em = (EventMessage) m;
	 lAID = em.getAID();

	 if (lAID == Const.CRLAID) {

	    cab.receiveServer(m);

	 } else {
   	 
	    am = new AppEventMessage(Const.CONTROL, em.getData());
	    cab.receiveApp(lAID, am);
 	   	             	      
	 } 
      }
    }
    System.out.println("ControlDemon: trying to end");
    endAll();
    System.out.println("ControlDemon: ending thread");
   
  }


  private void endAll() {

    System.out.println("ControlDemon: releasing references");   
    cs = null;
    apps = null;
    reg = null;
    lb = null;
    cab = null;
    q.clear();
    q = null;    
    th = null;
 
  }

  private void emergLogout() {

    cs.logout();

  }

}


